/**
 * 
 */
package x1.monitoring;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * @author joe
 * 
 */
public class SimpleTest {
  private static final Log log = LogFactory.getLog(SimpleTest.class);

  @Before
  public void setup() {
    service = new MonitoringServiceImpl();
  }

  @Test
  public void systemLoadTest() throws Exception {
    for (int i = 0; i < 10; i++) {
      SystemLoad systemLoad = service.getSystemLoad();
      assertNotNull(systemLoad);
      log.info(systemLoad.toString());
      Thread.sleep(100);
    }
  }

  @Test
  public void systemDiskUsage() throws Exception {
    for (int i = 0; i < 10; i++) {
      FilesystemUsage fileSystemUsages = service.getDiskUsage();
      for (DiskUsage diskUsage : fileSystemUsages.getDiskUsages()) {
        assertNotNull(diskUsage);
        log.info(diskUsage.toString());
      }
      Thread.sleep(100);
    }
  }
  
  @Test
  public void classUsage() throws Exception {
    for (int i = 0; i < 10; i++) {
      ClassUsage classUsage = service.getClassUsage();
      assertNotNull(classUsage);
      log.info(classUsage.toString());
      Thread.sleep(100);
    }
  }
  
  @Test
  public void memoryUsage() throws Exception {
    for (int i = 0; i < 10; i++) {
      MemoryUsage memoryUsage = service.getMemoryUsage();
      assertNotNull(memoryUsage);
      log.info(memoryUsage.toString());
      Thread.sleep(100);
    }
  }

  private MonitoringService service;
}
