package echo;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;

import org.eclipse.jetty.websocket.WebSocket;
import org.eclipse.jetty.websocket.WebSocketServlet;

public class EchoServlet extends WebSocketServlet {
  private static final long serialVersionUID = 3777423323062956075L;

  protected WebSocket doWebSocketConnect(HttpServletRequest req, String resp) {
    return new EchoWebSocket();
  }
  
  private class EchoWebSocket implements WebSocket {
    private Outbound outbound;
    
    @Override
    public void onConnect(Outbound outbound) {
      this.outbound = outbound;
    }
    
    @Override
    public void onDisconnect() {
      this.outbound = null;
    }
    
    @Override
    public void onMessage(final byte frame, String data) {
      try {
        System.out.println("Received: " + data);
        outbound.sendMessage("You said: " + data);
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
    
    @Override
    public void onMessage(byte arg0, byte[] arg1, int arg2, int arg3) {
    }
    @Override
    public void onFragment(boolean arg0, byte arg1, byte[] arg2, int arg3, int arg4) {
    }
  }
  

}
