var wsUri = "ws://" + window.location.host + "/monitoring/ws";
var websocket;

function init() {
	writeToScreen("Not Connected to server", "output", "warning");
	testWebSocket();
}

function toggle() {
	if (websocket != null) {
		stop();
	} else {
		init();
	}
}
function stop() {
	websocket.send('disconnect');
	websocket = null;
	document.getElementById("toggle").value = "start";
}
function testWebSocket() {
	websocket = new WebSocket(wsUri);
	websocket.onopen = function(evt) {
		onOpen(evt)
	};
	websocket.onclose = function(evt) {
		onClose(evt)
	};
	websocket.onmessage = function(evt) {
		onMessage(evt)
	};
	websocket.onerror = function(evt) {
		onError(evt)
	};
	document.getElementById("toggle").value = "stop";
}

function onOpen(evt) {
	writeToScreen("Connected to server", "output");
	doSend("connect: Hello are you there WebSocket Server?");
}

function onClose(evt) {
	writeToScreen("Server stopped", "output", "warning");
	websocket = null;
	document.getElementById("toggle").value = "start";
}

function onMessage(evt) {
	var data = eval('(' + evt.data + ')');
	var aTable = "<table>";
	if (data.id == 'os') {
		//pushData(data.id, data.timestamp, data.processCpuUsage);
		aTable = aTable + "<tr><th>Name:</th><th>Operating System</th></tr>";
		aTable = aTable + "<tr><td>OS:</td><td>" + data.name + "</td></tr>";
		aTable = aTable + "<tr><td># Processors:</td><td>" + data.numProcessors
				+ "</td></tr>";
		aTable = aTable + "<tr><td>Load average:</td><td>"
				+ data.systemLoadAverage + "</td></tr>";
		aTable = aTable + "<tr><td>CPU Usage:</td><td>" + data.processCpuUsage
				+ "%</td></tr>";
	} else if (data.id == 'class') {
		//pushData(data.id, data.timestamp, data.loadedClassCount);
		aTable = aTable + "<tr><th>Name:</th><th>Class Loader</th></tr>";
		aTable = aTable + "<tr><td>Compiler:</td><td>" + data.name
				+ "</td></tr>";
		aTable = aTable + "<tr><td># Loaded Classes:</td><td>"
				+ data.loadedClassCount + "</td></tr>";
		aTable = aTable + "<tr><td>Compilation time:</td><td>"
				+ data.totalCompilationTime + "</td></tr>";
		aTable = aTable + "<tr><td># Total Loaded Classes:</td><td>"
				+ data.totalLoadedClassCount + "</td></tr>";
		aTable = aTable + "<tr><td># Unloaded Classes:</td><td>"
				+ data.unloadedClassCount + "</td></tr>";
	} else if (data.id == 'disk') {
		aTable = aTable + "<tr><th>Name:</th><th>Disk usage</th></tr>";
		for ( var i = 0; i < data.diskUsages.length; i++) {
			var diskUsage = data.diskUsages[i];
			var meg = 1024 * 1024;
			aTable = aTable + "<tr><td>Drive:</td><td>" + diskUsage.name
					+ "</td></tr>";
			aTable = aTable + "<tr><td>Total:</td><td>"
					+ Math.floor(diskUsage.totalSpace / meg) + " MB</td></tr>";
			aTable = aTable + "<tr><td>Free:</td><td>"
					+ Math.floor(diskUsage.freeSpace / meg) + " MB</td></tr>";
			aTable = aTable + "<tr><td>Usable:</td><td>"
					+ Math.floor(diskUsage.usableSpace / meg) + " MB</td></tr>";
		}
	} else if (data.id == 'memory') {
		//pushData(data.id, data.timestamp, data.heapMemoryUsageUsed);
		aTable = aTable + "<tr><th>Name:</th><th>Memory</th></tr>";
		var meg = 1024 * 1024;
		aTable = aTable + "<tr><td>Heap Memory Used:</td><td>"
				+ Math.floor(data.heapMemoryUsageUsed / meg) + " MB</td></tr>";
		aTable = aTable + "<tr><td>Heap Memory Init:</td><td>"
				+ Math.floor(data.heapMemoryUsageInit / meg) + " MB</td></tr>";
		aTable = aTable + "<tr><td>Heap Memory Committed:</td><td>"
				+ Math.floor(data.heapMemoryUsageCommitted / meg)
				+ " MB</td></tr>";
		aTable = aTable + "<tr><td>Heap Memory Max:</td><td>"
				+ Math.floor(data.heapMemoryUsageMax / meg) + " MB</td></tr>";
		aTable = aTable + "<tr><td>Non Heap Memory Used:</td><td>"
				+ Math.floor(data.nonHeapMemoryUsageUsed / meg)
				+ " MB</td></tr>";
		aTable = aTable + "<tr><td>Non Heap Memory Init:</td><td>"
				+ Math.floor(data.nonHeapMemoryUsageInit / meg)
				+ " MB</td></tr>";
		aTable = aTable + "<tr><td>Non Heap Memory Committed:</td><td>"
				+ Math.floor(data.nonHeapMemoryUsageCommitted / meg)
				+ " MB</td></tr>";
		aTable = aTable + "<tr><td>Non Heap Memory Max:</td><td>"
				+ Math.floor(data.nonHeapMemoryUsageMax / meg)
				+ " MB</td></tr>";
	}
	var timestamp = new Date(data.timestamp);
	aTable = aTable + "<tr><td>Timestamp:</td><td>" + timestamp.toGMTString()
			+ "</td></tr>";
	aTable = aTable + "</table>";
	writeToScreen(aTable, data.id, 'info');
	
	//draw(data.id);
		
	writeToScreen('DATA RECEIVED ' + data.id, 'output');
}

function onError(evt) {
	writeToScreen(evt.data, 'output', 'error');
}

function doSend(message) {
	writeToScreen("SENT: " + message, 'output');
	websocket.send(message);
}

function writeToScreen(message, id, rule) {
	var output = document.getElementById(id);
	output.innerHTML = message;
	output.className = rule;
}

if (window.addEventListener) {
	window.addEventListener("load", init, false);
} else {
	window.attachEvent("onload", init);
}